
function string:vexalarm_Msgs_split(splitter)
	local returnvalue = {}
	for part in string.gmatch(self, ".-"..splitter) do
		part = string.gsub(part, splitter, "")
		returnvalue[#returnvalue+1] = part
	end
	return returnvalue
end

function vexalarm_Msgs_recSP_RE(msg, sender)
	if vexalarm.sentMsgs[msg] == sender then
		vexalarm.sentMsgs[msg] = nil
		vexalarm.SendSuccess = true
		vexalarm_optionTab_SpellProfiles_feedback("send", "Spellprofile has been successfully sent", false)
		vexalarm_initialize(true)
	end
end

function vexalarm_Msgs_recSP(msg, sender)
	local content = msg:vexalarm_Msgs_split(";")	
	
	local timestamp = content[1]
	vexalarm.testTimeStamp = timestamp
	local name = content[2]
	local part = tonumber(content[3])
	local quantity = tonumber(content[4])
	local package = content[5]
	
	if vexalarm.incomeMsgs[timestamp] == nil then
		vexalarm.incomeMsgs[timestamp] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["parts"] == nil then
		vexalarm.incomeMsgs[timestamp]["parts"] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["received"] == nil then
		vexalarm.incomeMsgs[timestamp]["received"] = {}
		for i=1, quantity do
			vexalarm.incomeMsgs[timestamp]["received"][i] = false
		end
	end
	
	vexalarm.incomeMsgs[timestamp]["received"][part] = true
	vexalarm.incomeMsgs[timestamp]["quantity"] = quantity
	vexalarm.incomeMsgs[timestamp]["parts"][part] = package
	
	local complete = true
	for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["received"]) do
		if not(v) then
			complete = false
		end
	end
	
	if complete then
		vexalarm.incomeSpellProfiles[timestamp] = {}
		
		local text = ""
		for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["parts"]) do
			text = text..v
		end
		
		local data = {}
		local spells = text:vexalarm_Msgs_split(",")	
		for i, v in ipairs(spells) do
			local spelldata = v:vexalarm_Msgs_split("=")
			data[spelldata[1]] = {}
			for j=1,4 do
				if string.sub(spelldata[2], j, j) == 1 then
					data[spelldata[1]][j] = true
				else
					data[spelldata[1]][j] = false
				end
			end
		end
		vexalarm.incomeSpellProfiles[timestamp]["data"] = data
						
		vexalarm.incomeSpellProfiles[timestamp]["timestamp"] = date("%d/%m/%y %H:%M")
		vexalarm.incomeSpellProfiles[timestamp]["name"] = name	
		vexalarm_initialize(true)
		print("|CFFFF7D0AVex Alarm|r - Spellprofile '"..name.."' from '"..sender.."' has been received")
		SendAddonMessage("VEXALARM_SP_RE", timestamp , "whisper" , sender)	
	end
end

function vexalarm_Msgs_send()
	local spellprofile = vexalarm_optionTab_SpellProfiles_profile
	local user = vexalarm_optionTab_SpellProfiles_target
	local packages = {}
	local timer = 0
	local currentpackage = 1
	
	vexalarm.SendSuccess = false
	
	if vexalarm_sp[spellprofile]~= nil and user ~= "" then
		for key in pairs(vexalarm_spells_defaults) do
			if timer>=15 then
				currentpackage = currentpackage + 1
				timer = 0
			end
			timer = timer + 1
			
			if packages[currentpackage] == nil then
				packages[currentpackage] = ""
			end
			
			local text = key.."="
			for i=1,4 do
				local boolean = 0
				if vexalarm_sp[spellprofile][key] ~= nil then
					if vexalarm_sp[spellprofile][key][i] ~= nil then
						if vexalarm_sp[spellprofile][key][i] then
							boolean = 1
						end
					end
				end
				text = text..boolean
			end
			text = text.."="
			
			packages[currentpackage] = packages[currentpackage]..text..","
		end
	end
	local msgcount = #packages
	if msgcount > 0 then
		local timestamp = GetTime()
		for i=1,msgcount do
			local text = timestamp..";"..spellprofile..";"..i..";"..msgcount..";"..packages[i]..";"
			SendAddonMessage("VEXALARM_SP", text , "whisper" , user)
		end
		vexalarm.sentMsgs[tostring(timestamp)] = user
	end
end