
vexalarm_optionTab_SpellProfiles_profile = ""
vexalarm_optionTab_SpellProfiles_name = ""
vexalarm_optionTab_SpellProfiles_newname = ""
vexalarm_optionTab_SpellProfiles_target = ""


vexalarm_optionTab_SpellProfiles_statusMsg = {
	["save"] = " ",
	["rename"] = " ",
	["load"] = " ",
	["send"] = " ",
	["saveRe"] = " "}

vexalarm_optionTab_SpellProfiles_RecSP = ""
vexalarm_optionTab_SpellProfiles_RecSP_newname = ""

function vexalarm_optionTab_SpellProfiles_feedback(category, text, error)
	for key in pairs(vexalarm_optionTab_SpellProfiles_statusMsg) do
		vexalarm_optionTab_SpellProfiles_statusMsg[key] = " "
	end
	if error then
		text = "|CFFC41F3B"..text.."|r"
	else
		text = "|CFF00FF00"..text.."|r"
	end
	if vexalarm_optionTab_SpellProfiles_statusMsg[category] ~= nil then
		vexalarm_optionTab_SpellProfiles_statusMsg[category] = text
	end
end

function vexalarm_optionTab_SpellProfiles_getList(addCurrent, showSet)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm_sp) do
		if showSet then
			local framesUsed = ""
			for frame,val in pairs (vexalarm_f_data) do
				if key == val["spelldata"]["spellprofile"] then
					if framesUsed ~= "" then
						framesUsed = framesUsed..", "
					end
					framesUsed = framesUsed..frame
				end
			end
			if vexalarm_data["rw"]["spelldata"]["spellprofile"] == key then
				if framesUsed ~= "" then
					framesUsed = framesUsed..", "
				end
				framesUsed = framesUsed.."RW"
			end
			if framesUsed == "" then
				returnvalue[key]=key
			else
				returnvalue[key]=key.." ("..framesUsed..")"
			end
		else
			returnvalue[key]=key
		end
		timer = timer + 1
	end
	if addCurrent then
		returnvalue[""] = "Current settings"
	elseif timer == 0 then
		returnvalue[""] = "No saved profile found"
	end
	
	return returnvalue
end

function vexalarm_optionTab_SpellProfiles_save()
	local key = vexalarm_optionTab_SpellProfiles_name
	
	if vexalarm_optionTab_General_checkName(key) then
		vexalarm_sp[key] = vexalarm_CopyTable(vexalarm_s)
		vexalarm_optionTab_SpellProfiles_name = ""
		
		vexalarm_optionTab_SpellProfiles_feedback("save", "Spell-profile saved successfully", false)
	end
end

function vexalarm_optionTab_SpellProfiles_rename()
	local key = vexalarm_optionTab_SpellProfiles_profile
	local name = vexalarm_optionTab_SpellProfiles_newname
	
	if vexalarm_optionTab_General_checkName(name) and vexalarm_sp[key]~=nil then
		if name ~= key then
			vexalarm_sp[name] = vexalarm_CopyTable(vexalarm_sp[key])
			vexalarm_sp[key] = nil
			vexalarm_optionTab_SpellProfiles_newname = name
			vexalarm_optionTab_SpellProfiles_profile = name
			
			vexalarm_optionTab_SpellProfiles_feedback("rename", "Spell-profile renamed successfully", false)
		else
			vexalarm_optionTab_SpellProfiles_feedback("rename", "Couldn't rename profile. Reason: The new name and the old name are the same.", true)
		end
	end
end

function vexalarm_optionTab_SpellProfiles_delete()
	local key = vexalarm_optionTab_SpellProfiles_profile
	
	if vexalarm_optionTab_General_checkName(key) then
		vexalarm_sp[key] = nil
		vexalarm_optionTab_SpellProfiles_profile = ""
		vexalarm_optionTab_SpellProfiles_newname = ""
			
		vexalarm_optionTab_SpellProfiles_feedback("load", "Spell-profile deleted successfully", false)
	end
end

function vexalarm_optionTab_SpellProfiles_load(key, slashcmd)
	if key == nil then
		key = vexalarm_optionTab_SpellProfiles_profile
	end
	if vexalarm_optionTab_General_checkName(key) then
		if vexalarm_sp[key] == nil then
			if slashcmd then
				print("|CFFFF7D0AVex Alarm|r - ERROR - Couldn't load spell-profile. Reason: Spell-profile '"..key.."' doesn't exist.")
			else
			vexalarm_optionTab_SpellProfiles_feedback("load", "Couldn't load spell-profile. Reason: Spell-profile '"..key.."' doesn't exist.", true)
			end
		else
			vexalarm_s = vexalarm_CopyTable(vexalarm_sp[key])
			vexalarm_Loader_LoadParamters(false)
			if slashcmd then
				print("|CFFFF7D0AVex Alarm|r - Spell-profile '"..key.."' has been loaded succesfully")
			else
				vexalarm_optionTab_SpellProfiles_feedback("load", "Spell-profile '"..key.."' has been loaded succesfully", false)
			end
		end
	end
end

function vexalarm_optionTab_SpellProfiles_recSPGetList()
	local returnvalue = {}
	for key,val in pairs(vexalarm.incomeSpellProfiles) do
		returnvalue[key] = val["timestamp"].." "..val["name"]
	end
	if #returnvalue == 0 then
		returnvalue[""] = "No received profile found"
	end
	return returnvalue
end

function vexalarm_optionTab_SpellProfiles_recSPSave()
	local key = vexalarm_optionTab_SpellProfiles_RecSP
	local name = vexalarm_optionTab_SpellProfiles_RecSP_newname
	if vexalarm_optionTab_General_checkName(name) then
		vexalarm_sp[name] = vexalarm_CopyTable(vexalarm.incomeSpellProfiles[key]["data"])
		vexalarm_spellprofiles_receivedprofile_load = ""
		vexalarm_spellprofiles_receivedprofile_name = ""
		
		vexalarm_optionTab_SpellProfiles_feedback("saveRe", "Received spell-profile saved successfully", false)
	end
end